package app.ara.utils.error;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Build;
import android.os.Looper;
import android.support.v7.app.AlertDialog;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;

/**
 * Created by ptitcois on 24/07/17.
 */
public class ErrorHandler {
    private static Object s_lock = new Object();
    public static ArrayList<String> s_errors = new ArrayList<String>();



    public static void addError(Activity context, Exception _e)
    {
        boolean add=true;
        String s = "Une erreur s'est produite:\n"+_e.getMessage()+"\n"+exceptionToString(_e);
        for(int i=0; i<s_errors.size(); i++)
            if(s.compareTo(s_errors.get(i))==0)
                add=false;
        if(add)
        {
            s_errors.add(s);
            context.finish();
        }
    }

    public static void handle(Activity context)
    {
        final Context c=context;
        while(s_errors.size()>0)
        {
            context.runOnUiThread(new Runnable() {
                public void run() {
                    AlertDialog.Builder builder;
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                        builder = new AlertDialog.Builder(c, android.R.style.Theme_Material_Dialog_Alert);
                    } else {
                        builder = new AlertDialog.Builder(c);
                    }


                    builder.setTitle("Erreur")
                            .setMessage(s_errors.get(0))
                            .setPositiveButton(android.R.string.yes, new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int which) {
                                }
                            })
                            .setNegativeButton(android.R.string.no, new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int which) {
                                }
                            })
                            .setIcon(android.R.drawable.ic_dialog_alert)
                            .show();
                }
            });
            s_errors.remove(0);
        }
    }


    public static void waitThread(Thread t)
    {
        synchronized (s_lock)
        {
            try {
                t.join();
            } catch (InterruptedException e1) {
                e1.printStackTrace();
            }
        }
    }

    public static void wakeThreadUp(Thread t)
    {
        synchronized (s_lock)
        {
            t.notify();
        }
    }

    public static void crash()
    {
        String n = null;
        n.getBytes();
    }

    private static String exceptionToString(Exception e)
    {
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        e.printStackTrace(pw);
        return sw.toString();
    }
}
